package osl.examples.inheritance.buffer;

import java.util.LinkedList;
import java.util.Queue;

import osl.manager.Actor;
import osl.manager.annotations.message;

public class UnboundedBuffer extends Actor {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6649111070929860492L;

	private Queue<Object> buffer = new LinkedList<Object>();
	
	@message 
	public void put(Object o) {
		buffer.offer(o);
	}
	
	@message 
	public Object get() {
		return buffer.poll();
	}
	
	@message
	public Integer size() {
		return buffer.size();
	}

}
