package osl.examples.sorting;
import java.util.Random;

import osl.manager.Actor;
import osl.manager.ActorName;
import osl.manager.RemoteCodeException;
import osl.manager.annotations.message;

public class Quicksort extends Actor {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5021339002556170557L;
	
	private Random generator = new Random(999999);
	
	@message
	public void boot(Integer size) throws RemoteCodeException 
	   {
	      int A[] = new int[size];
	      for (int i=0 ; i < size; i++)
	         A[i] = generator.nextInt(1000000);
	      
		   System.out.println("Before sorting: ");
				for (int i=0; i < size; i++) 
					System.out.print(A[i] + " ");
	      System.out.println();
	
				ActorName sorter = create(Quicksort.class);

	      callByRef(sorter, "sort", A, 0, size-1);

		  System.out.println("After sorting: ");
	      for (int i=0; i < size; i++) 
	      {
	      	if (i > 0 && A[i-1] > A[i])
	      	{
	      		System.out.println("Error!!!");
	      		break;
	      	}
			System.out.print(A[i] + " ");
		  }
		  System.out.println();
	   }
	
		@message
		public void sort(int A[], Integer f, Integer l) throws RemoteCodeException 
		   {
		      if (f >= l) return;
		      int pivot_index = partition(A, f, l);
		      ActorName sorter1 = create(Quicksort.class);
		      callByRef(sorter1, "sort", A, f, pivot_index - 1);
		      ActorName sorter2 = create(Quicksort.class);
		      callByRef(sorter2, "sort", A, pivot_index+1, l);
		   }
	
			private int partition(int A[], int f, int l)
			   {
						int pivot = A[f];
						int low = f + 1;
						
						for (int i = low; i <= l; i ++)
						{
							if (A[i] <= pivot)
							{
								swap(A, i, low);
								low++;
							}
						}
						swap (A, f, low-1);
			      return low-1;
			   }
			
			   private void swap (int A[], int x, int y)
			   {
			   		if (x == y) return;
			      int temp = A[x];
			      A[x] = A[y];
			      A[y] = temp;
			   }
			

}
